<template>
  <div>
    <!-- COMIENZO DE LA VISTA -->
    <div class="padding-top">
      <el-header height="110px" style="margin: 0 8rem">
        <el-col :span="24" class="text-end">
          <!-- REGRESAR A LA LISTA DE ENLATADOS CON MODAL -->
          <ReturnButton
            v-if="!idEdit"
            v-on:clickEvent="verifyModal"
            :offsetArrow="20"
            :spanTitle="3"
            title="Ir a Materiales"
          ></ReturnButton>
          <!-- REGRESAR A LA LISTA DE ENLATADOS SIN MODAL -->
          <ReturnButton
            v-else
            v-on:clickEvent="verifyEditModal"
            :offsetArrow="20"
            :spanTitle="3"
            title="Ir a Materiales"
          ></ReturnButton>
        </el-col>
        <!-- ENUNCIADO DE ACUERDO SI ES NUEVO O ES EDITAR -->
        <el-col :span="24" style="padding-top: 1.5rem">
          <el-card
            :body-style="{ padding: '10px' }"
            v-if="idEdit"
            shadow="never"
            class="bg-form text-white title-views"
            >Editar Material</el-card
          >
          <el-card
            v-else
            :body-style="{ padding: '10px' }"
            shadow="never"
            class="bg-form text-white title-views"
            >Nuevo Material</el-card
          >
        </el-col>
      </el-header>
      <!-- CUERPO DEL FORMULARIO-->
      <el-main style="margin: 3rem 8rem">
        <el-form :rules="rules" ref="form" :model="validateForm">
          <!-- SECCION DE TITULOS -->
          <h4 class="text-orange" style="margin-bottom: 2rem">
            TÍTULOS DEL MATERIAL
          </h4>
          <!-- INPUT DE TITULO ORIGINAL -->
          <el-row>
            <el-col :span="23" :offset="1">
              <el-form-item
                label="Título Original:"
                prop="originalTitle"
                class="inputTitleMat"
              >
                <el-input
                  v-if="idEdit"
                  v-model.trim="materialEdit.originalTitle"
                  size="small"
                  @keyup.enter.native="addTitles"
                  show-word-limit
                  maxlength="60"
                ></el-input>
                <el-input
                  v-else
                  v-model="form.originalTitle"
                  size="small"
                  @keyup.enter.native="addTitles"
                  show-word-limit
                  maxlength="60"
                ></el-input>
              </el-form-item>
            </el-col>
          </el-row>
          <!-- INPUT DE TITULO ESPAÑOL/SUGERIDO -->
          <el-row>
            <el-col :span="23" :offset="1">
              <el-form-item
                label="Título Español y/o Sugerido:"
                prop="ownTitle"
                class="inputTitleMat"
              >
                <el-input
                  v-if="idEdit"
                  v-model.trim="materialEdit.ownTitle"
                  size="small"
                  show-word-limit
                  maxlength="60"
                ></el-input>
                <el-input
                  v-else
                  v-model="form.ownTitle"
                  size="small"
                  show-word-limit
                  maxlength="60"
                ></el-input>
              </el-form-item>
            </el-col>
          </el-row>
          <!-- INPUT DE TITULO COMERCIAL -->
          <el-row>
            <el-col :span="23" :offset="1">
              <el-form-item
                label="Título Comercial:"
                prop="listTitle"
                class="inputTitleMat"
              >
                <el-input
                  v-if="idEdit"
                  v-model.trim="materialEdit.listTitle"
                  size="small"
                  show-word-limit
                  maxlength="60"
                ></el-input>
                <el-input
                  v-else
                  v-model="form.listTitle"
                  size="small"
                  show-word-limit
                  maxlength="60"
                ></el-input>
              </el-form-item>
            </el-col>
          </el-row>

          <hr style="margin-top: 2.5rem" />

          <!-- SECCION DE DURACION DEL MATERIAL -->
          <h4 class="text-orange" style="margin: 3rem 0 2rem">
            DURACIÓN DEL MATERIAL
          </h4>
          <el-row v-if="idEdit">
            <el-col :span="3" :offset="1">
              <el-form-item style="margin: 0" prop="hoursMaterial">
                <el-input
                  size="small"
                  v-model="materialEdit.hoursMaterial"
                  placeholder="00"
                  v-on:keypress.native="isNumber"
                  @keyup.enter.native="$refs.jump1.focus"
                  maxlength="2"
                >
                  <template slot="append">hr</template>
                </el-input>
              </el-form-item>
            </el-col>
            <el-col :span="3" :offset="1">
              <el-form-item style="margin: 0" prop="minutesMaterial">
                <el-input
                  size="small"
                  v-model="materialEdit.minutesMaterial"
                  placeholder="00"
                  v-on:keypress.native="isNumber"
                  ref="jump1"
                  maxlength="2"
                >
                  <template slot="append">min</template>
                </el-input>
              </el-form-item>
            </el-col>
          </el-row>

          <el-row v-else>
            <el-col :span="3" :offset="1">
              <el-form-item style="margin: 0" prop="hoursMaterial">
                <el-input
                  size="small"
                  v-model="form.hoursMaterial"
                  placeholder="00"
                  v-on:keypress.native="isNumber"
                  @keyup.enter.native="$refs.jump1.focus"
                  maxlength="2"
                >
                  <template slot="append">hr</template>
                </el-input>
              </el-form-item>
            </el-col>
            <el-col :span="3" :offset="1">
              <el-form-item style="margin: 0" prop="minutesMaterial">
                <el-input
                  size="small"
                  v-model="form.minutesMaterial"
                  placeholder="00"
                  v-on:keypress.native="isNumber"
                  ref="jump1"
                  maxlength="2"
                >
                  <template slot="append">min</template>
                </el-input>
              </el-form-item>
            </el-col>
          </el-row>

          <hr style="margin-top: 2.5rem" />

          <!-- SECCION DE CAPITULOS DEL MATERIAL -->
          <h4 class="text-orange" style="margin: 3rem 0 2rem">
            CAPÍTULOS DEL MATERIAL
          </h4>
          <p class="text-reference">
            *Solo llenar si el material contiene capítulos
          </p>

          <div v-if="!idEdit">
            <el-row
              v-for="(item, index) in form.numChapters"
              :key="index"
              style="margin-bottom: 0.5rem"
            >
              <ChapterComponent
                :item="item"
                @verificate="verificarInformacion"
                @changeTotalCaps="changeTotalCaps"
                @changeCap="changeCap"
              />
            </el-row>
          </div>

          <div v-else>
            <el-row
              v-for="(item, index) in numChaptersEdit"
              :key="index"
              style="margin-bottom: 0.5rem"
            >
              <ChapterComponent
                :item="item"
                @verificate="verificarInformacion"
                @changeTotalCaps="changeTotalCaps"
                @changeCap="changeCap"
              />
            </el-row>
          </div>

          <hr style="margin-top: 2.5rem" />

          <!-- SECCION DE CARACTERÍSTICAS DEL MATERIAL -->
          <h4 class="text-orange" style="margin: 3rem 0 2rem">
            CARACTERÍSTICAS DEL MATERIAL
          </h4>
          <!-- INPUT DE TIPO DE MATERIAL -->
          <el-row>
            <el-col :span="23" :offset="1">
              <el-form-item
                label="Tipo de Material:"
                prop="materialType"
                class="selectElMat"
              >
                <el-cascader
                  v-if="idEdit"
                  prop="materialType"
                  size="small"
                  style="width: 100%"
                  expand-trigger="hover"
                  :options="options"
                  v-model="materialEdit.materialType"
                  @change="handleChangeMat"
                ></el-cascader>

                <el-cascader
                  v-else
                  size="small"
                  style="width: 100%"
                  expand-trigger="hover"
                  :options="options"
                  v-model="form.materialType"
                  @change="handleChangeMat"
                ></el-cascader>
              </el-form-item>
            </el-col>
          </el-row>
          <!-- INPUT DE TIPO DE CONTENIDO -->
          <el-row>
            <el-col :span="23" :offset="1">
              <el-form-item
                label="Tipo de Contenido:"
                prop="typeOfContent"
                class="selectElMat"
              >
                <el-select
                  v-if="idEdit"
                  @change="generateCodeTypeCont(materialEdit.typeOfContent)"
                  v-model="materialEdit.typeOfContent"
                  placeholder="Seleccionar"
                  size="small"
                  style="width: 100%"
                >
                  <el-option
                    v-for="materialContent in optionsTypeOfContent"
                    :key="materialContent._id"
                    :label="materialContent.label"
                    :value="materialContent.label"
                  ></el-option>
                </el-select>
                <el-select
                  v-else
                  @change="generateCodeTypeCont(form.typeOfContent)"
                  v-model="form.typeOfContent"
                  placeholder="Seleccionar"
                  size="small"
                  style="width: 100%"
                >
                  <el-option
                    v-for="mtypeContent in optionsTypeOfContent"
                    :key="mtypeContent._id"
                    :label="mtypeContent.label"
                    :value="mtypeContent.label"
                  ></el-option>
                </el-select>
              </el-form-item>
            </el-col>
          </el-row>
          <!-- INPUT DE CENTRO DE COSTO -->
          <el-row>
            <el-col :span="8" :offset="1">
              <el-form-item
                label="Centro de Costo:"
                prop="costCenter"
                class="selectElMat"
              >
                <el-autocomplete
                  v-if="idEdit"
                  placeholder="codigo"
                  v-model="materialEdit.costCenter"
                  style="width: 100%"
                  size="small"
                  :fetch-suggestions="querySearchCodeCostCenter"
                  :trigger-on-focus="false"
                  @select="handleSelectCostCenter"
                >
                  <template slot-scope="props">
                    <div>{{ props.item.code }}</div>
                  </template>
                </el-autocomplete>

                <el-autocomplete
                  v-else
                  placeholder="codigo"
                  v-model="form.costCenter"
                  style="width: 100%"
                  size="small"
                  :fetch-suggestions="querySearchCodeCostCenter"
                  :trigger-on-focus="false"
                  @select="handleSelectCostCenter"
                >
                  <template slot-scope="props">
                    <div>{{ props.item.code }}</div>
                  </template>
                </el-autocomplete>
              </el-form-item>
            </el-col>
            <el-col :span="10">
              <el-form-item prop="costCenterName">
                <el-autocomplete
                  v-if="idEdit"
                  placeholder="Buscar por nombre"
                  v-model="materialEdit.costCenterName"
                  style="width: 100%"
                  size="small"
                  :fetch-suggestions="querySearchNameCostCenter"
                  :trigger-on-focus="false"
                  @select="handleSelectCostCenter"
                >
                  <template slot-scope="props">
                    <div>{{ props.item.name }}</div>
                  </template>
                </el-autocomplete>
                <el-autocomplete
                  v-else
                  placeholder="Buscar por nombre"
                  v-model="form.costCenterName"
                  style="width: 100%"
                  size="small"
                  :fetch-suggestions="querySearchNameCostCenter"
                  :trigger-on-focus="false"
                  @select="handleSelectCostCenter"
                >
                  <template slot-scope="props">
                    <div>{{ props.item.name }}</div>
                  </template>
                </el-autocomplete>
              </el-form-item>
            </el-col>
          </el-row>
          <!-- INPUT DE GENERO -->
          <el-row>
            <el-col :span="23" :offset="1">
              <el-form-item label="Género:" prop="genre" class="selectElMat">
                <el-select
                  v-if="idEdit"
                  v-model="materialEdit.genre"
                  multiple
                  collapse-tags
                  placeholder="Seleccionar"
                  size="small"
                  style="width: 100%;"
                >
                  <el-option
                    style="text-transform: capitalize;"
                    v-for="(genre,index) in genders"
                    :key="index"
                    :label="genre.name"
                    :value="genre.code"
                  ></el-option>
                </el-select>

                <el-select
                  v-else
                  v-model="form.genre"
                  multiple
                  collapse-tags
                  placeholder="Seleccionar"
                  size="small"
                  style="width: 100%;"
                >
                  <el-option
                    style="text-transform: capitalize;"
                    v-for="(genre,index) in genders"
                    :key="index"
                    :label="genre.name"
                    :value="genre.code"
                  ></el-option>
                </el-select>
              </el-form-item>
            </el-col>
          </el-row>

          <hr style="margin-top:2.5rem" />

          <!-- SECCION DE VIGENCIAS DEL MATERIAL -->
          <h4 class="text-orange" style="margin: 3rem 0 2rem">
            VIGENCIAS DEL MATERIAL
          </h4>
          
          <el-form-item
            v-if="idEdit"
            prop="validityTab"
            style="margin-left: 2.4rem"
          >
            <el-button
              icon="el-icon-circle-plus"
              style="margin-bottom: 1rem"
              size="small"
              @click="addTab(tabsValue)"
              >Añadir</el-button
            >
            <el-tabs
              v-model="tabsValue"
              type="card"
              closable
              @tab-remove="removeTab"
            >
              <el-tab-pane
                v-for="(item, index1) in materialEdit.validity"
                :key="index1"
                :label="item.title"
                :name="item.name"
              >
                <div class="block" style="margin-top: 1rem">
                  <span style="margin-right: 0.5rem">Inicio:</span>
                  <el-date-picker
                    v-model="item.startValidity"
                    @input="
                      validatestartDate({
                        date: item.startValidity,
                        index: index1,
                        type: 'update',
                      })
                    "
                    format="MM/dd/yyyy"
                    type="date"
                    size="small"
                    :picker-options="pickerEndDate"
                  ></el-date-picker>
                </div>

                <div class="block" style="margin-bottom: 1rem">
                  <span style="margin-right: 1.4rem">Fin:</span>
                  <el-date-picker
                    v-model="item.endValidity"
                    format="MM/dd/yyyy"
                    type="date"
                    size="small"
                    :picker-options="pickerStartDate"
                  ></el-date-picker>
                </div>
              </el-tab-pane>
            </el-tabs>
          </el-form-item>
          <!-- SECCION DE VIGENCIAS DEL MATERIAL CUANDO ES UN NUEVO ENLATADO -->
          <el-form-item v-else prop="validityTab" style="margin-left: 2.4rem">
            <el-button
              icon="el-icon-circle-plus"
              style="margin-bottom: 1rem"
              size="small"
              @click="addTab(editableTabsValue)"
              >Añadir</el-button
            >
            <el-tabs
              v-model="editableTabsValue"
              type="card"
              closable
              @tab-remove="removeTab"
            >
              <el-tab-pane
                v-for="(item, index1) in editableTabs2"
                :key="index1"
                :label="item.title"
                :name="item.name"
              >
                <div class="block" style="margin-top: 1rem">
                  <span style="margin-right: 0.5rem">Inicio:</span>
                  <el-date-picker
                    v-model="item.contentStart"
                    @input="
                      validatestartDateCreated({
                        date: item.contentStart,
                        index: index1,
                        type: 'created',
                      })
                    "
                    type="date"
                    size="small"
                    format="MM/dd/yyyy"
                    :picker-options="pickerEndDateCreated"
                  ></el-date-picker>
                </div>
                <div class="block" style="margin-bottom: 1rem">
                  <span style="margin-right: 1.4rem">Fin:</span>
                  <el-date-picker
                    v-model="item.contentEnd"
                    type="date"
                    size="small"
                    format="MM/dd/yyyy"
                    :picker-options="pickerStartDateCreated"
                  ></el-date-picker>
                </div>
              </el-tab-pane>
            </el-tabs>
          </el-form-item>

          <hr style="margin-top: 2.5rem" />

          <!-- SECCION DE CANAL DE TRANSMISION -->
          <h4 class="text-orange" style="margin: 3rem 0 2rem">
            CANAL DE TRANSMISIÓN
          </h4>
          <el-row style="margin-bottom: 1rem">
            <el-col :span="6" :offset="1">
              <el-checkbox-group
                v-if="idEdit"
                v-model="materialEdit.checkedChanels"
                @change="gettingChannels"
              >
                <el-checkbox
                  v-for="channel in channels"
                  :label="channel"
                  :key="channel"
                  style="display: block; margin: 1rem 0 2rem 0"
                >
                  <div>{{ channel }}</div>
                </el-checkbox>
              </el-checkbox-group>

              <el-checkbox-group
                v-else
                v-model="form.checkedChannels"
                @change="gettingChannels"
              >
                <el-checkbox
                  v-for="channel in channels"
                  :label="channel"
                  :key="channel"
                  style="display: block; margin: 1rem 0 2rem 0"
                >
                  <div>{{ channel }}</div>
                </el-checkbox>
              </el-checkbox-group>
            </el-col>
          </el-row>

          <hr style="margin-top: 2.5rem" />

          <!-- SECCION DE SEÑALES -->
          <h4 class="text-orange" style="margin: 3rem 0 2rem">SEÑALES</h4>
          <el-row style="margin-bottom: 1rem">
            <!-- MARCAR LAS OPCIONES DE TODAS O SELECCIONAR-->
            <el-col :span="6" :offset="1">
              <el-checkbox
                :indeterminate="isIndeterminate"
                v-model="checkAll"
                @change="handleCheckAllChange"
                border
                >Todas las señales
              </el-checkbox>
            </el-col>
            <el-col :span="6">
              <el-button @click="signalModal = true">Seleccionar</el-button>
            </el-col>
            <!-- MODAL DE LAS SEÑALES -->
            <el-dialog
              :visible.sync="signalModal"
              width="40%"
              center
              :show-close="false"
              :close-on-press-escape="false"
              custom-class="dialog-orange"
            >
              <el-form-item style="margin: 0" prop="checkedSignals">
                <!-- MUESTRA LISTA DE SEÑALES PARA EDICION DE ENLATADO -->
                <el-checkbox-group
                  v-if="idEdit" 
                  v-model="materialEdit.checkedSignals"
                  @change="handleCheckedSignalsChange"
                  class="text-center"
                  style="margin-left: 3rem"
                >
                  <el-checkbox
                    v-for="signal in signals"
                    :label="signal"
                    :key="signal"
                    style="width: 30%; margin: 0"
                    class="text-start"
                    >{{ signal }}</el-checkbox
                  >
                </el-checkbox-group>
                <!-- MUESTRA LISTA DE SEÑALES PARA NUEVO ENLATADO -->
                <el-checkbox-group
                  v-else
                  v-model="form.checkedSignals"
                  @change="handleCheckedSignalsChange"
                  class="text-center"
                  style="margin-left: 3rem"
                >
                  <el-checkbox
                    v-for="signal in signals"
                    :label="signal"
                    :key="signal"
                    style="width: 30%; margin: 0"
                    class="text-start"
                    >{{ signal }}</el-checkbox
                  >
                </el-checkbox-group>
              </el-form-item>
              
              <div style="text-align: right; margin-top: 20px">
                <el-button
                  @click="signalModal = false"
                  class="text-orange border-orange"
                  >CANCELAR</el-button
                >
                <el-button @click="signalModal = false" type="primary"
                  >ACEPTAR</el-button
                >
              </div>
            </el-dialog>
          </el-row>
          <!-- RECUADRO DE SEÑALES -->
          <el-form-item style="margin: 0 0 6rem 2.4rem" prop="checkedSignals">
            <div class="bg-gray">
              <!-- RECUADRO SI EL ENLATADO EXISTE -->
              <div
                v-if="idEdit"
                style="display: table; height: 3.5rem; padding: 10px 7px 7px"
              >
                <el-col
                  v-for="(aitem, k) in materialEdit.checkedSignals"
                  :key="k"
                  class="bg-white"
                  style="margin: 7px; padding: 1px 5px; width: 8rem"
                  >{{ aitem }}</el-col
                >
              </div>
              <!-- RECUADRO SI ES ENLATADO NUEVO -->
              <div
                v-else
                style="display: table; height: 3.5rem; padding: 10px 7px 7px"
              >
                <el-col
                  v-for="(item, j) in form.checkedSignals"
                  :key="j"
                  class="bg-white"
                  style="margin: 7px; padding: 1px 5px; width: 8rem"
                  >{{ item }}</el-col
                >
              </div>
            </div>
          </el-form-item>


          <!-- SECCION DE BOTONES FINALES -->
          <div class="text-end">
            <!-- BOTON DE CANCELAR -->
            <el-button
              v-on:click="modalCancelButton = true"
              class="text-orange border-orange"
              >CANCELAR</el-button
            >
            <!-- BOTON DE INGRESAR / ACTUALIZAR -->
            <el-button
              @click="submitForm('form')"
              type="primary"
              :disabled="isDisabledToUpdate"
            >
              <span v-if="idEdit">ACTUALIZAR</span>
              <span v-else>INGRESAR</span>
            </el-button>
          </div>
        
          <!-- COMPONENTE MODAL PARA ALERTAR UNA CANCELACION DEL FORMULARIO -->
          <AppModalDanger
            :show-dialog.sync="modalCancelButton"
            v-if="modalCancelButton"
            v-on:btnEvent="viewListMaterials"
            @btnEvent="modalCancelButton = false"
            v-on:eventBtn="modalCancelButton = false"
          ></AppModalDanger>
          <!-- COMPONENTE MODAL PARA ALERTAR UNA CANCELACION DE CAPITULOS -->
          <AppModalDanger
            :show-dialog.sync="modalCortesButton"
            v-if="modalCortesButton"
            @btnEvent="modalCortesButton = false"
            @eventBtn="modalCortesButton = false"
            parrafo="Los capítulos de este material tienen información en soporte o revisión"
          >
            <template>
              <br />
              <p>
                ¿Esta seguro que desea borrar la información
                <strong>{{ textCortesCapitulos }}</strong
                >?
              </p>
            </template>
          </AppModalDanger>
          <!-- COMPONENTE MODAL PARA INDICAR LA CREACION DE UN ENLATADO EXITOSO-->
          <AppModalSuccess
            :show-dialog.sync="addMaterialModal"
            v-if="addMaterialModal"
            :styleModal="true"
            :parrafo="
              'El material <strong> ' +
              form.originalTitle.toProperCase() +
              ' </strong> se ha agregado a la lista. <br> Su código es <strong>' +
              this.nuevocodigoMaterial +
              '</strong> . '
            "
            btn1="Ver materiales"
            @btnEvent="viewListMaterials"
            btn2="Nuevo material"
            @eventBtn="newMaterialResetForm"
          ></AppModalSuccess>
          <!-- MODAL PARA ALERTAR FORMULARIO INVALIDO -->
          <el-dialog
            :visible.sync="invalidForm"
            width="30%"
            center
            :show-close="false"
            custom-class="dialog-red"
          >
            <el-row>
              <el-col :span="5">
                <img
                  src="@/assets/images/alerta.svg"
                  width="80%"
                  alt="emoticon"
                />
              </el-col>
              <el-col :span="18" :offset="1">
                <p style="line-height: 22px">
                  Por favor, ingrese todos los campos requeridos.
                </p>
              </el-col>
            </el-row>
          </el-dialog>

          <!-- MODAL PARA ALERTAR QUE TIENE QUE MODIFICAR LOS CORTES ANTES DE MODIFICAR LA HORA DEL MATERIAL  -->
          <el-dialog
            :visible.sync="needEditCuts"
            width="30%"
            center
            :show-close="false"
            custom-class="dialog-red"
          >
            <el-row>
              <el-col :span="6">
                <img
                  src="@/assets/images/alerta.svg"
                  width="70%"
                  alt="emoticon"
                />
              </el-col>
              <el-col :span="18">
                <p style="line-height: 22px">
                  La duración de los cortes, no puede ser
                  <span class="text-red text-bold">MAYOR</span> a la duración
                  del material.
                </p>
                <br />
                <p style="line-height: 22px">
                  Puedes modificar la duracion del
                  <span class="text-orange">MATERIAL,</span> o disminuir los
                  <span class="text-orange">CORTES</span>.
                </p>
              </el-col>
            </el-row>
          </el-dialog>

          <!-- COMPONENTE MODAL PARA INDICAR QUE UN ENLATADO FUE ACTUALIZADO -->
          <AppModalSuccess
            :show-dialog.sync="updateModal"
            v-if="updateModal"
            :styleModal="true"
            :parrafo="
              'El material <strong>' +
              materialEdit.originalTitle.toProperCase() +
              '</strong> se ha se actualizado. <br> '
            "
            btn1="ACEPTAR"
            v-on:btnEvent="updateModal = false"
            @btnEvent="viewListMaterials"
          />
        </el-form>
      </el-main>
    </div>

    <!-- MODAL DEL BTN DE REGRESAR -->
    <AppModal
      :show-dialog.sync="returnButtonModal"
      v-if="returnButtonModal"
      nameClass="dialog-red"
      :rutImg="require(`@/assets/images/alerta.svg`)"
      sizeImg="80px"
      textBold="¡Un momento!"
      :parrafo="'Si sales del formulario la información se perderá.'"
      v-on:btnEvent="returnButtonModal = false"
      @btnEvent="viewListMaterials"
      v-on:eventBtn="returnButtonModal = false"
      btn1="SALIR"
      btn2="SEGUIR AQUÍ"
      classBtn1="border-red"
      typeBtn1="danger"
    />

    <!-- COMPONENTE MODAL CAPITULO A ELIMINAR CONTIENE CORTES -->
    <AppModal
      :show-dialog.sync="alertHaveCuts"
      v-if="alertHaveCuts"
      nameClass="dialog-red"
      :rutImg="require(`@/assets/images/alerta.svg`)"
      sizeImg="80%"
      :parrafo="'<strong>Antes de editar los capítulos, debes modificar los cortes del material.</strong>'"
    />
  </div>
</template>

<script>
// IMPORTAR COLECCION DE GETTERS DE VUEX
import { mapGetters } from 'vuex'
// IMPORTAR COMPONENTES
import AppModal from '@/components/AppModal.vue'
import AppModalDanger from '@/components/AppModalDanger.vue'
import AppModalSuccess from '@/components/AppModalSuccess.vue'
import ChapterComponent from '@/components/ChapterComponent.vue'
import ReturnButton from '@/components/ReturnButton.vue'
// IMPORTAR DESDE ENUMS.JS
// import { typeOfContent } from '@/enums.js'
// IMPORTAR DESDE MAIN.JS
import { HTTP } from '@/main.js'
// IMPORTAR DESDE UTILS.JS
import { addTimes, restTimes } from '@/utils/calculateTime.js'
import {
  calculateHour,
  verificatedCutsEnd,
  getTime,
  calculateRestTimeForCuts,
} from '@/utils/calculateTimePrograms.js'
import { modifyText } from '@/utils/modifyText.js'
import { isCanned } from '@/utils/validateIsCanned.js'

// COLOCA EN MAYUSCULA EL PRIMER CARACTER DE CADA PALABRA
String.prototype.toProperCase = function () {
  const re = /(^|[^A-Za-zÁÉÍÓÚÜÑáéíóúüñ])(?:([a-záéíóúüñ])|([A-ZÁÉÍÓÚÜÑ]))|([A-ZÁÉÍÓÚÜÑ]+)/gu
  return this.replace(
    re,
    (m, caracterPrevio, minuscInicial, mayuscInicial, mayuscIntermedias) => {
      const locale = ['es', 'gl', 'ca', 'pt', 'en']
      if (mayuscIntermedias) return mayuscIntermedias.toLocaleLowerCase(locale)
      return (
        caracterPrevio +
        (minuscInicial
          ? minuscInicial.toLocaleUpperCase(locale)
          : mayuscInicial)
      )
    }
  )
}

/**
  * @vue-data {Array} genders - Propiedad donde se almacena la lista de generos
  * @vue-data {Array} channels - Canales de transmision (América TV, América Next')
  * @vue-data {Array} options - Opciones de tipo de material (enlatado y afiliacion/televisa)
  * @vue-data {String} idEdit - Id del material ("" || !== "")
  * @vue-data {Object} materialEdit - Aqui se almacenara los datos del material(GET method) que se pondra en edicion
  * @vue-data {Boolean} updateModal - Default: false - Cambiara a true cuando se actualice un material
  * @vue-data {Object} form - Formulario del material enlatado
  * @vue-data {Array} rules - Reglas con las validaciones en cada campo del formulario
  * @vue-data {String} editMin - 
  * @vue-data {String} editHours - 
  * @vue-data {Array} numChaptersEdit - almacena el objeto de temporada, capitulos, etc
  * @vue-data {Array} numChapters - 
  * @vue-data {Array} signalsTable - 
  * @vue-data {Boolean} isIndeterminate - 
  * @vue-data {Boolean} addMaterialModal - 
  * @vue-data {Boolean} returnButtonModal - 
  * @vue-data {Boolean} modalCancelButton - 
  * @vue-data {Boolean} checkAll - 
  * @vue-data {Boolean} signalModal - 
  * @vue-data {Number} editableTabsValue - 
  * @vue-data {Array} editableTabs2 - 
  * @vue-data {Number} tabIndex - 
  * @vue-data {}  - 
  * @vue-data {}  - 
  * @vue-data {}  - 
  * @vue-data {}  - 
  * @vue-data {}  - 
  * @vue-data {}  - 
  * @vue-data {}  - 
  * @vue-data {}  - 
  * @vue-data {}  - 
  * @vue-data {}  - 
  * @vue-data {}  - 
  */

export default {
  components: {
    ReturnButton,
    AppModalDanger,
    AppModalSuccess,
    AppModal,
    ChapterComponent,
  },
  updated(){
    // console.log()
  },
  data() {
    return {
      genders: [],
      channels: ['América TV', 'América Next'],
      options: [
        {
          value: 'Enlatado',
          label: 'Enlatado',
        },
        {
          value: 'Afiliación',
          label: 'Afiliación',
          children: [
            {
              value: 'Televisa',
              label: 'Televisa',
            },
          ],
          stringMaterialType: '',
        },
      ],
      idEdit: JSON.parse(this.$localStorage.get('materialId')),
      materialEdit: {},
      updateModal: false,
      form: {
        originalTitle: '', 
        ownTitle: '',
        listTitle: '',
        duration: '',
        numChapters: [
          {
            chapters: '',
            season: '',
            infoByChapter: [],
            seasonString: '',
            TypeOfChapters: '',
          },
        ],
        typeOfContent: '',
        genre: '',
        costCenter: '',
        costCenterName: '',
        hoursMaterial: '01',
        minutesMaterial: '00',
        checkedSignals: [
          'Arequipa',
          'Chiclayo',
          'Chimbote',
          'Digital',
          'Huancayo',
          'Lima',
          'Piura',
          'Pucallpa',
          'T1',
          'T2',
          'Tacna',
          'Trujillo',
          'Web',
          "Puno",
          "Cusco",
          "Ica",
          "Tarapoto",
          "Iquitos",
          "Tumbes",
          "Cajamarca",
          "Discovery Channel",
          "Canal N",
          "Televisa"
        ],
        materialType: [],
        checkedChannels: ['América TV'],
      },
      rules: {
        originalTitle: [
          {
            required: true,
            message: 'Por favor ingrese este campo',
            trigger: 'change',
          },
        ],
        ownTitle: [
          {
            required: true,
            message: 'Por favor ingrese este campo',
            trigger: 'change',
          },
        ],
        listTitle: [
          {
            required: true,
            message: 'Por favor ingrese este campo',
            trigger: 'change',
          },
        ],
        typeOfContent: [
          {
            required: true,
            message: 'Por favor seleccione un valor',
            trigger: 'change',
          },
        ],
        costCenter: [
          {
            required: true,
            message: 'Por favor seleccione un valor',
            trigger: 'change',
          },
        ],
        hoursMaterial: [
          { required: true, message: 'Ingrese este campo', trigger: 'change' },
        ],
        minutesMaterial: [
          { required: true, message: 'Ingrese este campo', trigger: 'change' },
        ],
      },
      editMin: '',
      editHours: '',
      numChaptersEdit: [],
      numChapters: [
        {
          chapters: '',
          season: '',
          infoByChapter: [],
          seasonString: '',
          TypeOfChapters: '',
        },
      ],
      signalsTable: [
        'AR',
        'CH',
        'CY',
        'DG',
        'HU',
        'LI',
        'PC',
        'PI',
        'T1',
        'T2',
        'TC',
        'TR',
        'WE',
        "PN",
        "CU",
        "IC",
        "TP",
        "IQ",
        "TB",
        "CJ",
        "DI",
        "CN",
        "TE"
      ], //Desde DB - Señales
      isIndeterminate: false,
      addMaterialModal: false,
      returnButtonModal: false,
      modalCancelButton: false,
      checkAll: true,
      signalModal: false,
      editableTabsValue: '1',
      editableTabs2: [
        {
          title: '1° Vigencia',
          name: '1',
          contentStart: null,
          contentEnd: null,
        },
      ],
      tabIndex: 1,
      validity: [], //formulario de nueva vigencia
      indx: 0,
      tabsValue: '1',
      editValidity: [], //formulario de editar vigencia
      validityString: [], //datos de vigencia en string
      code: '', //para mostrar codigo en modal
      userName: '',
      userEmail: localStorage.getItem('userEmail'),
      stringMaterialType: '',
      nuevocodigoMaterial: '',
      nuevoCodigoGeminis: '',
      typeContentIndex: [],
      codeTypeContent: '',
      signalsCode: '',
      signals: [],
      signalsByCode: [],
      previousSigns: [],
      optionsCostCenter: [],
      invalidForm: false,
      pickerStartDate: {
        disabledDate: this.disabledDueDate,
      },
      pickerEndDate: {
        disabledDate: this.disabledEnd,
      },
      pickerStartDateCreated: {
        disabledDate: this.disabledDueDateCreated,
      },
      pickerEndDateCreated: {
        disabledDate: this.disabledEndCreated,
      },
      startValidityDate: '',
      endValidityDate: '',
      contador: 0,
      prevTotalChapters: '',
      alertHaveCuts: false,
      isDisabledToUpdate: false,
      count: 0,
      isModifyDurationMat: false,
      esNecesarioEditarLosMateriales: false,
      needEditCuts: false,
      signalNext: [],
      modalCortesButton: false,
      textCortesCapitulos: '',
      originalMaterial: {},
      codeTypeInGrid: ""
    }
  },
  async created() {
    this.gettingUsername()
    await this.getSignals()
    await this.fetchMaterial()
    this.getCostCenter()
    await this.$store.dispatch('getData', 'typeMaterial')
  },
  // computed: devolver valores en caché hasta que las dependencias cambian
  computed: {
    ...mapGetters([
      "listOfCannedContentType",
      "listOfTelevisionContentType"
    ]),
    optionsTypeOfContent() {
      return this.listOfCannedContentType
    },
    optionsTypeOfContentTelevision() {
      return this.listOfTelevisionContentType
    },
    /*<-- CONDICIONAL: SI EL ID EXISTE LA DATA SE ALMACENA (GET) EN materialEdit SINO SE INICIALIZA CON FORM -->*/
    validateForm() {
      let materialId = JSON.parse(this.$localStorage.get('materialId'))
      if (materialId) {
        return this.materialEdit
      } else {
        return this.form
      }
    },
    /* <-- CONVERSION: DE ARRAY A STRING SEPARADO X COMAS - HORAS Y MINUTOS --> */
    verifyChangeHours() {
      const array = [
        this.materialEdit.hoursMaterial,
        this.materialEdit.minutesMaterial,
      ].join()
      return array
    },
    /* <-- CONVERSION: DE ARRAY A STRING SEPARADO X COMAS - materialEdit Y numChaptersEdit --> */
    verifyChangeModal() {
      const array = [
        this.materialEdit.originalTitle,
        this.materialEdit.ownTitle,
        this.materialEdit.listTitle,
        this.materialEdit.duration,
        this.materialEdit.typeOfContent,
        this.materialEdit.hoursMaterial,
        this.materialEdit.minutesMaterial,
        this.materialEdit.checkedSignals,
        this.materialEdit.duration,
        this.materialEdit.materialType,
        this.materialEdit.costCenter,
        this.materialEdit.genre,
        //this.materialEdit.minutesMaterial,
        this.numChaptersEdit[0] ? this.numChaptersEdit[0].chapters : [],
        this.numChaptersEdit[0] ? this.numChaptersEdit[0].season : [],
        this.materialEdit.classification,
        this.materialEdit.checkedChanels,
        this.materialEdit.validity && this.materialEdit.validity.length > 0
          ? this.materialEdit.validity[0].endValidity
          : [],
        this.materialEdit.validity && this.materialEdit.validity.length > 0
          ? this.materialEdit.validity[0].startValidity
          : [],
        this.materialEdit.validity && this.materialEdit.validity.length > 0
          ? this.materialEdit.validity.length
          : 0,
        this.materialEdit.validity === null ? this.materialEdit.validity = [] : this.materialEdit.validity,
        this.materialEdit.signalsCode
          ? this.materialEdit.signalsCode.length
          : 0,
      ].join()
      return array
    },
  },
  methods: {
    /* <-- VALIDACION: LIGADO AL ESTADO canned (que dependera de donde sea registrado el material) --> */
    isCanned(val) {
      return isCanned(val)
    },
    /**
     * <-- VALIDACION: DEFINE LOS CAPITULOS DE UN MATERIAL -->
     * @param {String} val.value - value es el valor del capitulo inicial o final
     * @param {String} val.element - element es una cadena que define si es el capitulo inicial o final
    */
    changeCap(val) {
      const { value, element } = val
      let editOrNew =
        this.idEdit == '' ? this.form.numChapters[0] : this.numChaptersEdit[0]
      if (String(value) == '0') {
        editOrNew[element] = 1
      }
      if (element == 'firstCap') {
        let valueSelect = value == '0' ? 1 : Number(value)
        let newLastCap = valueSelect + Number(editOrNew.chapters) - 1
        editOrNew.lastCap = newLastCap
      } else {
        let valueSelect = value == '0' ? 1 : Number(value)
        let newLastCap = valueSelect - Number(editOrNew.chapters) + 1
        editOrNew.firstCap = newLastCap < 0 ? 1 : newLastCap
        editOrNew.chapters =
          Number(editOrNew.lastCap) - Number(editOrNew.firstCap) + 1
      }
    },
    /* <-- RESET: DEVUELVE VALORES A SU ESTADO VACIO / LIMPIA VALORES DEL FORMULARIO --> */
    newMaterialResetForm() {
      this.cleanAllInputs('form')
      this.isIndeterminate = false
      this.checkAll = true
      this.form.checkedSignals = [
        'Arequipa',
        'Chiclayo',
        'Chimbote',
        'Digital',
        'Huancayo',
        'Lima',
        'Piura',
        'Pucallpa',
        'T1',
        'T2',
        'Tacna',
        'Trujillo',
        'Web',
        "Puno",
        "Cusco",
        "Ica",
        "Tarapoto",
        "Iquitos",
        "Tumbes",
        "Cajamarca",
        "Discovery Channel",
        "Canal N",
        "Televisa"
      ]
      this.signalsTable = [
        'AR',
        'CH',
        'CY',
        'DG',
        'HU',
        'LI',
        'PC',
        'PI',
        'T1',
        'T2',
        'TC',
        'TR',
        'WE',
        "PN",
        "CU",
        "IC",
        "TP",
        "IQ",
        "TB",
        "CJ",
        "DI",
        "CN",
        "TE"
      ]
      this.addMaterialModal = false
    },
    /**
     * <-- VALIDACION: TRAE LA INFO DEL CAPITULO SELECCIONADO -->
     * <-- VALIDACION: ANALIZA SI EL NUMERO DE CAPITULOS ESTA CAMBIANDO CON RESPECTO A LOS EXISTENTES -->
     * @param {Object} value - value contiene $event y item, se dispara al editar numero de capitulos
     * @param {Object} element.item - item contiene "TypeOfChapters", "chapters", "firstCap", "infoByChapter", "lastCap", "season", "seasonString"
     * @param {String} element.event - event es el número de capitulos
    */
    verificarInformacion(value) { 
      //console.log("value",value)
      const { item, event } = value
      // trae los capitulos mayores al número de capitulo
      const informacionCapitulos = item.infoByChapter.filter(
        (info) => info.chapter > parseInt(item.chapters)
      )
      const capitulosRevAndSop = informacionCapitulos.filter(
        (cap) =>
          (cap.radio != undefined &&
            cap.radio != null &&
            cap.radio != 'pendiente') ||
          (cap.state != undefined && cap.state != null)
      )
      const numeroCapitulos = capitulosRevAndSop.map((cap) => cap.chapter)
      if (capitulosRevAndSop.length > 0) {
        // cuando el n de capitulos = 0
        if (parseInt(item.chapters) == 0)
          this.textCortesCapitulos = 'de todos los capítulos'
        // cuando la diferencia entre la longitud del array infoByChapter menos el n de capitulos es igual a 1
        else if (item.infoByChapter.length - parseInt(item.chapters) == 1)
          this.textCortesCapitulos = `del capítulo ${
            parseInt(item.chapters) + 1
          }`
        // para otros casos
        else
          this.textCortesCapitulos = `del capítulo ${
            parseInt(item.chapters) + 1
          } al ${item.infoByChapter.length}`
        this.modalCortesButton = true
      }
    },
    /**Trae los datos del centro de costo con su codigo y el nombre
     * <-- VALIDACION: 1.SI EXISTE EL ID DEL MATERIAL / 2.SI EL costCenterName DENTRO DE materialEdit ESTA DEFINIDO --> 
     * @param {String} item - Puede ser el "code" o "name" del centro de costo
    */
    handleSelectCostCenter(item) {
      //console.log({item})
      if (JSON.parse(this.$localStorage.get('materialId'))) {
        this.materialEdit.costCenterName == undefined
          ? this.$set(this.materialEdit, 'costCenterName', item.name)
          : (this.materialEdit.costCenterName = item.name)
        this.materialEdit.costCenter = item.code
      } else {
        this.form.costCenterName = item.name
        this.form.costCenter = item.code
      }
    },
    // <-- NO SE USA EN ESTA PAGINA  -->
    createFilter(queryString) {
      return (link) => {
        return modifyText(link.name).indexOf(modifyText(queryString)) === 0
      }
    },
    /** 
     * <-- PETICION GET: TRAE LOS CENTROS DE COSTOS FILTRADOS POR NOMBRE -->
     * @param {String} queryString - Texto del nombre que se va escribiendo
    */
    querySearchNameCostCenter(queryString, cb) {
      this.getCostCenter({ name: queryString, code:"" }).then((res) => cb(res))
    },
    /** 
     * <-- PETICION GET: TRAE LOS CENTROS DE COSTOS FILTRADOS POR CODIGO -->
     * @param {String} queryString - Texto del codigo que se va escribiendo
    */
    querySearchCodeCostCenter(queryString, cb) {
      this.getCostCenter({ code: queryString, name:"" }).then((res) => cb(res))
    },
    /**Mofica la duracion de un material tomando en cuenta la cantidad y el tiempo de los cortes
    * @param {String} type - String que define el tip de corte
    * @param {Array} arrayCortes - cantidad de cortes de un capitulo
    */
    modificandoLaDuracionArtisticaSiTieneCortes(
      type,
      arrayCortes,
      restHour,
      newHour
    ) {
      let newDuration = restHour
      if (type == 'allChapters') {
        for (let i = 0; i < arrayCortes.cuts.length; i++) {
          if (arrayCortes.cuts[i + 1]) {
            newDuration = restTimes(newDuration, arrayCortes.cuts[i].duration)
          } else {
            newDuration = restTimes(newDuration, arrayCortes.cuts[i].duration)
          }
          console.log(newDuration, 'newDuration')
        }
        arrayCortes.artisticDuration = newDuration
        return arrayCortes
      } else {
        arrayCortes.map((el, i, arr) => {
          for (let j = 0; j < el.cuts.length; j++) {
            if (el.cuts[j + 1]) {
              newDuration = restTimes(newDuration, el.cuts[j].duration)
            } else {
              newDuration = restTimes(newDuration, el.cuts[j].duration)
            }
          }
          el.artisticDuration = newDuration
          newDuration = restHour
        })
        return arrayCortes
      }
    },
    /**Validacion si la cantidad de cortes no superen la duracion del material
    * @param {Array} videoCutting - Lista de los cortes a validar
    */
    verificandoSiLosCortesSuperanLaDuracionDelMaterial(videoCutting) {
      let durationMat =
        this.materialEdit.hoursMaterial +
        ':' +
        this.materialEdit.minutesMaterial +
        ':00'
      if (
        (videoCutting && videoCutting.individualChapters.length > 0) ||
        (videoCutting && videoCutting.chapterRanges.length > 0) ||
        (videoCutting && videoCutting.allChapters.cuts.length > 0)
      ) {
        if (videoCutting.allChapters.cuts.length > 0) {
          if (
            videoCutting.allChapters.cuts[
              videoCutting.allChapters.cuts.length - 1
            ].end > durationMat
          ) {
            console.log('necesita editar los cortes del material 1')
            this.esNecesarioEditarLosMateriales = true
          } else {
            this.esNecesarioEditarLosMateriales = false
            console.log(
              this.esNecesarioEditarLosMateriales,
              'this.esNecesarioEditarLosMateriales FALSE'
            )
          }
        } else {
          if (videoCutting.individualChapters.length > 0) {
            videoCutting.individualChapters.map((el, i, arr) => {
              if (el.cuts[el.cuts.length - 1].end > durationMat) {
                console.log('necesita editar los cortes del material 2')
                this.esNecesarioEditarLosMateriales = true
              } else {
                this.esNecesarioEditarLosMateriales = false
                console.log(
                  this.esNecesarioEditarLosMateriales,
                  'this.esNecesarioEditarLosMateriales FALSE'
                )
              }
            })
          }
          if (videoCutting.chapterRanges.length > 0) {
            videoCutting.chapterRanges.map((el, i, arr) => {
              if (el.cuts[el.cuts.length - 1].end > durationMat) {
                console.log('necesita editar los cortes del material 3')
                this.esNecesarioEditarLosMateriales = true
              } else {
                this.esNecesarioEditarLosMateriales = false
                console.log(
                  this.esNecesarioEditarLosMateriales,
                  'this.esNecesarioEditarLosMateriales FALSE'
                )
              }
            })
          }
        }
      }
    },
    verifyModal() {
      if (
        this.editableTabs2[0].contentStart ||
        this.editableTabs2[0].contentEnd ||
        this.form.checkedSignals.length ||
        this.form.originalTitle ||
        this.form.ownTitle ||
        this.form.listTitle ||
        this.form.typeOfContent ||
        this.form.genre ||
        this.form.costCenter ||
        this.form.materialType.length ||
        this.form.classification
      ) {
        this.returnButtonModal = true
      } else {
        this.viewListMaterials()
      }
    },
    verifyEditModal() {
      if (this.contador > 1) {
        this.returnButtonModal = true
      } else {
        this.$router.push({ name: 'material2' })
      }
    },
    /**
     * <-- PETICION POST: Envia "name" o "code" para su busqueda y retorna coincidencias -->
     * @param {Object} filter - dependiendo de cual este vacio es de que manera va a filtar
    */
    async getCostCenter(filter) {
      let { data } = await HTTP.post('orclCostCenter/filter', filter)
      return data
    },
    // <-- PETICION GET: TRAE LISTA DE SEÑALES -->
    async getSignals() {
      const { data } = await HTTP.get('tables/tableName/allSignals')
      if (data) {
        const { types, description } = data.table[0]
        // types es el nombre de las señales y description son los codigos
        this.signals = types 
        this.signalsTable = types
        this.signalsByCode = description
        this.signalsCode = description
      }
    },
    /** Compara los datos del centro de costo dependiendo del codigo
    * @param {String} val - Codigo del centro de costo seleccionadose
    */
    generateCodeTypeCont(val) {
      let property = ""
      if(this.stringMaterialType !== '') {
        if(this.stringMaterialType === 'Enlatado') {
          property = "optionsTypeOfContent"
        } else {
          const getFilterValue = this.optionsTypeOfContentTelevision.map((e) => e.label)
          const findContent = getFilterValue.includes(val) ? "optionsTypeOfContentTelevision" : "optionsTypeOfContent"
          property = findContent
        }
        const {value, codeTypeInGrid} =  this[property].find((option) => option.label === val)
        this.codeTypeContent = value
        this.codeTypeInGrid = codeTypeInGrid
      }
    },
    arraySignalCode(val) {
      let arrayIndex = []
      for (var x = 0; x < val.length; x++) {
        for (var y = 0; y < this.signals.length; y++) {
          if (this.signals[y] == val[x]) {
            arrayIndex.push(y)
          }
        }
      }

      return arrayIndex
    },
    /** <-- PETICION GET/LOCALSTORAGE: TRAE DATOS DEL MATERIAL SI EXISTE UN ID --> */
    async fetchMaterial() {
      const materialId = JSON.parse(this.$localStorage.get('materialId'))
      if (materialId) {
        console.log({ materialId })
        const { data } = await HTTP.get('materials/' + materialId)
        const { hoursMaterial, minutesMaterial } = data.material
        this.originalMaterial = JSON.parse(JSON.stringify(data.material))
        this.materialEdit = data.material
        this.$set(
          this.materialEdit,
          'beforeDurationMaterial',
          `${calculateHour(hoursMaterial)}:${calculateHour(minutesMaterial)}:00`
        )
        this.codeTypeContent = this.materialEdit.codeTypeContent
        this.stringMaterialType = this.materialEdit.stringMaterialType
        this.previousSigns = this.materialEdit.signalsCode
        let indexNext = ''
        this.materialEdit.signalsCode.map((signal, i) => {
          if (signal == 'NX') {
            indexNext = i
          }
        })

        if (indexNext !== '') {
          // SI HAY SEÑAL AMERICA NEXT
          this.signalsCode = this.materialEdit.signalsCode.filter(
            (signal) => signal !== 'NX'
          )
          this.signalNext = ['NX']
        } else {
          // NO HAY SEÑAL AMERICA NEXT
          this.signalsCode = this.materialEdit.signalsCode
        }

        // Transforma numChapters para acoplarse al array solicitado
        if (data.material.numChapters.length > 0) {
          const { firstCap, lastCap, chapters } = data.material.numChapters[0]
          if (Number(chapters) > 1 && !firstCap) {
            this.$set(data.material.numChapters[0], 'firstCap', '1')
          }
          if (Number(chapters) > 1 && !lastCap) {
            this.$set(data.material.numChapters[0], 'lastCap', String(chapters))
          }
          console.log({ a: data.material.numChapters })
          this.numChaptersEdit = data.material.numChapters
        } else {
          this.numChaptersEdit = [
            {
              chapters: '',
              season: '',
              seasonString: '',
              infoByChapter: [],
              firstCap: null,
              lastCap: null,
            },
          ]
        }

        this.prevTotalChapters = this.numChaptersEdit[0].chapters
        //agregando title y name de las tabs en edicion de vigencia

        console.log('this.materialEdit.validity',this.materialEdit.validity)

        if (this.materialEdit.validity) {
          this.materialEdit.validity.map((el, i, arr) => {
            this.$set(el, 'title', '')
            this.$set(el, 'name', '')
            this.indx = i + 1
            el.title = `${this.indx}° Vigencia`
            el.name = this.indx + ''
          })
          console.log(this.materialEdit.validity)
        }
        /*seteando la 1era fecha de las vigencias*/
        if (
          this.materialEdit.validity &&
          this.materialEdit.validity.length > 0
        ) {
          this.startValidityDate = this.materialEdit.validity[0]
            ? this.materialEdit.validity[0].startValidity
            : ''
          this.endValidityDate = this.materialEdit.validity[0]
            ? new Date(
                this.materialEdit.validity[0].endValidity
              ).toLocaleDateString('en-GB')
            : ''
        }

        if (
          this.materialEdit.validity &&
          this.materialEdit.validity.length == 0 &&
          !this.materialEdit.validity[0] ||
          this.materialEdit.validity === null
        ) {
          this.materialEdit.validity = this.editableTabs2
        }


        let haveSignals = []
        this.signalsCode.forEach((e) => {
          if (e !== '') {
            haveSignals.push(e)
          }
        })
        /**tiene señales */
        if (haveSignals.length > 0) {
          this.isDisabledToUpdate = false
        } else {
          this.isDisabledToUpdate = true
        }

        let conditional =
          haveSignals.length == this.signals.length ? true : false
        if (conditional == true) {
          this.isIndeterminate = false
          this.checkAll = true
        } else {
          this.isIndeterminate = true
          this.checkAll = false
        }
        console.log({ signalsCode: this.signalsCode, haveSignals })
      }
    },
    handleChangeMat(value) {
      let array = value
      if (array.length > 1) {
      }
      let string = ''
      array.map((el, i) => {
        if (i !== array.length - 1) {
          string += el + '-'
        } else {
          string += el
        }
      })
      this.stringMaterialType = string
      /*Cuando cambia el tipo de material y el typeOfContent ya esta seleccionado */
      let edit
      this.idEdit ? (edit = 'materialEdit') : (edit = 'form')

      this.optionsTypeOfContent.map((el, i, arr) => {
        if (el.label == this[edit].typeOfContent) {
          if (this.stringMaterialType !== 'Enlatado') {
            switch (el.label) {
              case 'Series':
                this.codeTypeContent = '201'
                break
              case 'Novelas':
                this.codeTypeContent = '202'
                break
              case 'Especial':
                this.codeTypeContent = '203'
                break
              case 'Programas Especiales':
                this.codeTypeContent = '203'
                break
            }
          } else {
            this.codeTypeContent = el.value
          }
          console.log(this.codeTypeContent, 'this.codeTypeContent')
        }
      })
    },
    addTab(targetName) {
      // edición de vigencia
      if (this.materialEdit.validity) {
        // let newTab = ++this.indx + ''
        let newTab
        if (this.materialEdit.validity.length > 0) {
          let value = Number(
            this.materialEdit.validity[this.materialEdit.validity.length - 1]
              .name
          )
          newTab = String(++value)
        } else {
          // newTab = ++this.indx + ''
          newTab = '1'
        }
        this.materialEdit.validity.push({
          title: `${newTab}° Vigencia`,
          name: newTab,
          startValidity: null,
          endValidity: null,
        })
        this.tabsValue = newTab
      } else {
        // nueva vigencia
        this.editableTabsValue = '1'
        let newTabName
        if (this.editableTabs2.length > 0) {
          let value = Number(
            this.editableTabs2[this.editableTabs2.length - 1].name
          )
          newTabName = String(++value)
        } else {
          newTabName = '1'
          // newTabName = ++this.tabIndex + ''
        }

        this.editableTabs2.push({
          title: `${newTabName}° Vigencia`,
          name: newTabName,
          contentStart: null,
          contentEnd: null,
        })
        this.editableTabsValue = newTabName
      }
    },
    removeTab(targetName) {
      console.log(targetName, 'removeTab')
      // eliminar tab de edicion de vigencia
      if (this.materialEdit.validity) {
        --this.indx
        let tabs = this.materialEdit.validity
        let activeName = this.tabsValue
        if (activeName === targetName) {
          tabs.forEach((tab, index) => {
            if (tab.name === targetName) {
              let nextTab = tabs[index + 1] || tabs[index - 1]
              if (nextTab) {
                activeName = nextTab.name
              }
            }
          })
        }
        this.tabsValue = activeName
        this.materialEdit.validity = tabs.filter(
          (tab) => tab.name !== targetName
        )
      } else {
        //eliminar tab de nueva vigencia
        let tabs = this.editableTabs2
        let activeName = this.editableTabsValue
        if (activeName === targetName) {
          tabs.forEach((tab, index) => {
            if (tab.name === targetName) {
              let nextTab = tabs[index + 1] || tabs[index - 1]
              if (nextTab) {
                activeName = nextTab.name
              }
            }
          })
        }
        this.editableTabsValue = activeName
        this.editableTabs2 = tabs.filter((tab) => tab.name !== targetName)
        // }
        console.log(this.editableTabs2, 'this.editableTabs2')
      }
    },
     /**Validacio de que solo sea numero
    * @param {Number} evt - valor que solo sea numero
    */
    isNumber(evt) {
      evt = evt ? evt : window.event
      var charCode = evt.which ? evt.which : evt.keyCode
      if (
        charCode > 31 &&
        (charCode < 48 || charCode > 57) &&
        charCode !== 46
      ) {
        evt.preventDefault()
      } else {
        return true
      }
    },
    /** Copia el titulo en los 3 campos al dar a la tecla Enter
    * @param {String} val - Texto enviado
    */
    addTitles(val) {
      if (this.form.originalTitle) {
        this.form.ownTitle = val ? this.form.originalTitle : ''
        this.form.listTitle = val ? this.form.originalTitle : ''
      } else if (this.materialEdit.originalTitle) {
        this.materialEdit.ownTitle = val ? this.materialEdit.originalTitle : ''
        this.materialEdit.listTitle = val ? this.materialEdit.originalTitle : ''
      }
    },
    /** <-- LOCALSTORAGE: TRAE EL NOMBRE DEL USUARIO CONECTADO EN ESE INSTANTE -->  */
    gettingUsername() {
      let user = this.userEmail.split('@')[0]
      this.userName = user.toUpperCase()
      //console.log(this.userName, ' this.userName')
    },
    deleteDuplicate(data, laschap) {
      let result = data
        .slice()
        .reverse()
        .filter(
          (v, i, a) =>
            a.findIndex(
              (t) => t.chapter === v.chapter && t.chapter <= laschap
            ) === i
        )
        .reverse()
      return result
    },
    /**Actualiza el material a los valores nuevos que se les asigne*/
    async updatedMaterial() {
      /*Reseteando el valor de estos elementos para que no aumente */
      this.editValidity = []
      this.validityString = []
      /*_____________ */
      if (this.materialEdit.minutesMaterial.length === 1) {
        this.materialEdit.minutesMaterial =
          '0' + this.materialEdit.minutesMaterial
      }
      if (this.materialEdit.hoursMaterial.length === 1) {
        this.materialEdit.hoursMaterial = '0' + this.materialEdit.hoursMaterial
      }

      //MODIFICANDO LAS PROPIEDADAES DE VIDEOCUTTING SI MODIFICA LA DURACION Y TIENE CORTES
      if (this.isModifyDurationMat) {
        let videoCutting = this.materialEdit.videoCutting
          ? this.materialEdit.videoCutting[0]
          : null
        let newHour =
          this.materialEdit.hoursMaterial +
          ':' +
          this.materialEdit.minutesMaterial +
          ':00'
        let restHour =
          this.materialEdit.hoursMaterial +
          ':' +
          this.materialEdit.minutesMaterial +
          ':00'
        //ENTRA SI TIENE CORTES
        if (
          (videoCutting && videoCutting.individualChapters.length > 0) ||
          (videoCutting && videoCutting.chapterRanges.length > 0) ||
          (videoCutting && videoCutting.allChapters.cuts.length > 0)
        ) {
          videoCutting.artisticDuration = newHour
          if (
            videoCutting.individualChapters.length > 0 ||
            videoCutting.chapterRanges.length > 0
          ) {
            if (videoCutting.individualChapters.length > 0) {
              let newInfoIndividuals = this.modificandoLaDuracionArtisticaSiTieneCortes(
                'diferente',
                videoCutting.individualChapters,
                this.materialEdit.hoursMaterial +
                  ':' +
                  this.materialEdit.minutesMaterial +
                  ':00'
              )
              videoCutting.individualChapters = newInfoIndividuals
            }
            if (videoCutting.chapterRanges.length > 0) {
              let newInfoRanges = this.modificandoLaDuracionArtisticaSiTieneCortes(
                'diferente',
                videoCutting.chapterRanges,
                this.materialEdit.hoursMaterial +
                  ':' +
                  this.materialEdit.minutesMaterial +
                  ':00'
              )
              videoCutting.chapterRanges = newInfoRanges
            }
          }
          if (videoCutting.allChapters.cuts.length > 0) {
            let newInfoAllChapter = this.modificandoLaDuracionArtisticaSiTieneCortes(
              'allChapters',
              videoCutting.allChapters,
              this.materialEdit.hoursMaterial +
                ':' +
                this.materialEdit.minutesMaterial +
                ':00'
            )
            videoCutting.artisticDuration = newHour
            videoCutting.allChapters = newInfoAllChapter
          }
        } else {
          if (videoCutting) {
            videoCutting.artisticDuration = newHour
            videoCutting.allChapters.artisticDuration = newHour
          }
        }
      }

      /* MODIFICANDO INFOBYCHAPTER SI SE AGREGAN O ELIMINA CAPITULOS MAS CAPITULOS*/
      if (this.materialEdit.numChapters.length !== 0) {
        
        if (this.materialEdit.numChapters[0].chapters == '') {
          this.materialEdit.numChapters = []
        } else if (
          this.materialEdit.numChapters[0].infoByChapter.length <
          Number(this.materialEdit.numChapters[0].chapters)
        ) {
          console.log('1')
          let totalCaps = []
          let objInsert = {}
          for (
            let i = Number(this.materialEdit.numChapters[0].firstCap);
            i <= Number(this.materialEdit.numChapters[0].lastCap);
            i++
          ) {
            totalCaps.push(i)
          }
          let chapInsertados = this.materialEdit.numChapters[0].infoByChapter.map(
            (e) => e.chapter
          )
          totalCaps.map((e) => {
            if (chapInsertados.includes(e) == false) {
              objInsert = {
                chapter: e,
                validity: this.materialEdit.validity,
                nameCap: 'Capítulo ' + e,
                state: 'sin revisar',
              }
              this.materialEdit.numChapters[0].infoByChapter.push(objInsert)
            }
          })
        } else if (
          Number(this.materialEdit.numChapters[0].chapters) <
          this.materialEdit.numChapters[0].infoByChapter.length
        ) {
          let laschap = this.materialEdit.numChapters[0].lastCap
          let data = this.materialEdit.numChapters[0].infoByChapter
          let response = await this.deleteDuplicate(data, laschap)
          this.materialEdit.numChapters[0].infoByChapter = response
          console.log('2')
        }
      } else {
        console.log('3')
        if (
          this.materialEdit.numChapters.length == 0 &&
          Number(this.numChaptersEdit[0].chapters) > 0
        ) {
          let objInsert = {}
          for (
            let i = Number(this.numChaptersEdit[0].firstCap);
            i <= Number(this.numChaptersEdit[0].lastCap);
            i++
          ) {
            if (this.numChaptersEdit[0].infoByChapter[i] == undefined) {
              objInsert = {
                chapter: i,
                validity: this.materialEdit.validity,
                nameCap: 'Capítulo ' + i,
                state: 'sin revisar',
              }
              this.numChaptersEdit[0].infoByChapter.push(objInsert)
            }
          }
          this.materialEdit.numChapters = this.numChaptersEdit
        }
      }
      let haveCaps = Boolean(this.numChaptersEdit[0].chapters)
      let groupData = []
      if (haveCaps == true) {
        let totalCaps = []
        let objInsert = {}
        for (
          let i = Number(this.materialEdit.numChapters[0].firstCap);
          i <= Number(this.materialEdit.numChapters[0].lastCap);
          i++
        ) {
          totalCaps.push(i)
        }
        let conditionalEditChap = null
        let conditionalNotExist = null
        if (this.originalMaterial.numChapters.length > 0) {
          conditionalEditChap =
            Number(this.originalMaterial.numChapters[0].firstCap) !==
              Number(this.numChaptersEdit[0].firstCap) &&
            Number(this.originalMaterial.numChapters[0].lastCap) !==
              Number(this.numChaptersEdit[0].lastCap)
          conditionalNotExist =
            !this.originalMaterial.numChapters[0].firstCap &&
            !this.originalMaterial.numChapters[0].lastCap
        }
        if (this.numChaptersEdit[0].length > 0) {
          conditionalNotExist = true
        }
        if(this.materialEdit.numChapters.length > 0) {
          groupData = this.materialEdit.numChapters[0].infoByChapter.map(
            (e, i) => {
              const { chapter, nameCap, ...rest } = e
              return {
                chapter: Number(this.numChaptersEdit[0].firstCap) + i,
                nameCap: `Capítulo ${
                  Number(this.numChaptersEdit[0].firstCap) + i
                }`,
                ...rest,
              }
            }
          )
          let capGroupData = groupData.map((cap) => cap.chapter)
          let joinGroupData = []
          groupData.map((e) => {
            if(totalCaps.includes(Number(e.chapter)) == true ) {
              joinGroupData.push(e)
            }
          })
          this.materialEdit.numChapters[0].seasonString =  `Temporada ${this.materialEdit.numChapters[0].season}`
          this.materialEdit.numChapters[0].infoByChapter = joinGroupData
        }
        this.$set(
          this.materialEdit.numChapters[0],
          'firstCap',
          Number(this.numChaptersEdit[0].firstCap)
        )
        this.$set(
          this.materialEdit.numChapters[0],
          'lastCap',
          Number(this.numChaptersEdit[0].lastCap)
        )
      }
      // editar vigencia
      if (this.materialEdit.validity && this.materialEdit.validity.length > 0) {
        this.materialEdit.validity.map((el, i, arr) => {
          let startValidityD = new Date(el.startValidity).getTime(),
            endValidityD = new Date(el.endValidity).getTime(),
            startValidity = startValidityD ? startValidityD : null,
            endValidity = endValidityD ? endValidityD : null
          if (i !== this.materialEdit.validity.length - 1) {
            let windowEnd = arr[i + 1].startValidity
              ? new Date(arr[i + 1].startValidity).getTime()
              : null
            let msWindowStart = endValidity
              ? endValidity + 1000 * 60 * 60 * 24
              : null
            let msWindowEnd = windowEnd ? windowEnd - 1000 * 60 * 60 * 24 : null
            this.editValidity.push({
              startValidity,
              endValidity,
              startWindow: msWindowStart,
              endWindow: msWindowEnd,
            })
            //añadiendo las vigencias y ventanas como strings a validityString
            this.validityString.push({
              startValidity: startValidity
                ? new Date(startValidity).toLocaleDateString('en-GB')
                : null,
              endValidity: endValidity
                ? new Date(endValidity).toLocaleDateString('en-GB')
                : null,
              startWindow: msWindowStart
                ? new Date(msWindowStart).toLocaleDateString('en-GB')
                : null,
              endWindow: msWindowEnd
                ? new Date(msWindowEnd).toLocaleDateString('en-GB')
                : null,
            })
          } else {
            this.editValidity.push({
              startValidity: startValidity,
              endValidity: endValidity,
            })
            this.validityString.push({
              startValidity: startValidity
                ? new Date(startValidity).toLocaleDateString('en-GB')
                : null,
              endValidity: endValidity
                ? new Date(endValidity).toLocaleDateString('en-GB')
                : null,
            })
          }
        })
      }

      console.log(
        this.materialEdit.numChapters,
        'this.materialEdit.numChapters'
      )

      let beforeDurationMaterial = `${calculateHour(
        this.materialEdit.hoursMaterial
      )}:${calculateHour(this.materialEdit.minutesMaterial)}:00`
      let durationMaterialCreated = this.createDateTimeForRol(
        `${calculateHour(this.materialEdit.hoursMaterial)}:${calculateHour(
          this.materialEdit.minutesMaterial
        )}:00`
      )
      //cambios para merge
       console.log(this.signalsCode.concat(this.signalNext), 'allsignals')
       const valueCanned = this.isCanned(this.materialEdit.materialType)

      let payload = {
        mat: [
          { propName: 'originalTitle', value: this.materialEdit.originalTitle.trim() },
          { propName: 'ownTitle', value: this.materialEdit.ownTitle.trim() },
          { propName: 'listTitle', value: this.materialEdit.listTitle.trim() },
          { propName: 'hoursMaterial', value: this.materialEdit.hoursMaterial },
          {
            propName: 'minutesMaterial',
            value: this.materialEdit.minutesMaterial,
          },
          { propName: 'genre', value: this.materialEdit.genre },
          { propName: 'costCenter', value: this.materialEdit.costCenter.trim() },
          { propName: 'numChapters', value: this.materialEdit.numChapters },
          { propName: 'typeOfContent', value: this.materialEdit.typeOfContent },
          { propName: 'codeTypeContent', value: this.codeTypeContent },
          { propName: 'materialType', value: this.materialEdit.materialType },
          { propName: 'stringMaterialType', value: this.stringMaterialType },
          {
            propName: 'checkedSignals',
            value: this.materialEdit.checkedSignals,
          },
          {
            propName: 'signalsCode',
            value: this.signalsCode.concat(this.signalNext),
          },
          { propName: 'previousSigns', value: this.previousSigns },
          { propName: 'videoCutting', value: this.materialEdit.videoCutting },
          { propName: 'validity', value: this.editValidity },
          { propName: 'validityString', value: this.validityString },
          { propName: 'userName', value: this.userName },
          { propName: 'userEmail', value: this.userEmail },
          { propName: 'codMaterial', value: this.materialEdit.codMaterial },
          {
            propName: 'checkedChanels',
            value: this.materialEdit.checkedChanels,
          },
          { propName: 'geminisCode', value: this.materialEdit.geminisCode },
          { propName: 'contractCode', value: this.materialEdit.contractCode },
          {
            propName: 'durationMaterialCreated',
            value: durationMaterialCreated,
          },
          { propName: 'beforeDurationMaterial', value: beforeDurationMaterial },
          { propName: 'isModifyDurationMat', value: this.isModifyDurationMat },
          {
            propName: 'costCenterName',
            value: this.materialEdit.costCenterName.trim(),
          },
          { propName: 'canned', value: valueCanned },
          { propName: 'codeTypeInGrid', value: this.codeTypeInGrid }
        ],
        id: this.idEdit,
        data: this.materialEdit,
        key: 'materials',
      }
      console.log(payload, 'data update')
      this.$store.dispatch('patchData', payload)
      this.$store.commit(
        'updateTextMaterialEnlatados',
        'Actualizando Materiales Enlatados...'
      )
      this.updatedAdmittMaterialContract()
      this.updateModal = true
    },
    updatedAdmittMaterialContract() {
      let dataChange = []
      console.log({
        originalMaterial: this.originalMaterial,
        materialEdit: this.materialEdit,
      })
      if (
        this.materialEdit.originalTitle !== this.originalMaterial.originalTitle
      ) {
        dataChange.push({ originalTitle: this.materialEdit.originalTitle })
      }
      if (this.materialEdit.ownTitle !== this.originalMaterial.ownTitle) {
        dataChange.push({ ownTitle: this.materialEdit.ownTitle })
      }
      if (this.materialEdit.listTitle !== this.originalMaterial.listTitle) {
        dataChange.push({ listTitle: this.materialEdit.listTitle })
      }
      if (
        this.materialEdit.typeOfContent !== this.originalMaterial.typeOfContent
      ) {
        dataChange.push({ typeOfContent: this.materialEdit.typeOfContent })
      }

      let value = {
        contractCode: this.materialEdit.contractCode,
        codMaterial: this.materialEdit.codMaterial,
        dataChange,
      }
      let conditional =
        this.materialEdit.contractCode !== null &&
        this.materialEdit.contractCode !== '' &&
        this.materialEdit.contractCode !== undefined
          ? true
          : false
      if (conditional == true) {
        HTTP.patch(
          `contracts/admittedMaterials/${this.materialEdit.contractCode}`,
          value
        )
      }
    },
    addWindows() {
      //Vigencia
      console.log('addWindows')
      this.editableTabs2.map((el, i, arr) => {
        let startValidityD = new Date(el.contentStart).getTime(),
          endValidityD = new Date(el.contentEnd).getTime(),
          startValidity = startValidityD ? startValidityD : null,
          endValidity = endValidityD ? endValidityD : null
        //con ventanas
        if (i !== this.editableTabs2.length - 1) {
          let windowEnd = arr[i + 1].contentStart
            ? new Date(arr[i + 1].contentStart).getTime()
            : null
          let msWindowStart = endValidity
            ? endValidity + 1000 * 60 * 60 * 24
            : null
          let msWindowEnd = windowEnd ? windowEnd - 1000 * 60 * 60 * 24 : null
          this.validity.push({
            startValidity,
            endValidity,
            startWindow: msWindowStart,
            endWindow: msWindowEnd,
          })
          this.validityString.push({
            startValidity: startValidity
              ? new Date(startValidity).toLocaleDateString('en-GB')
              : null,
            endValidity: endValidity
              ? new Date(endValidity).toLocaleDateString('en-GB')
              : null,
            startWindow: msWindowStart
              ? new Date(msWindowStart).toLocaleDateString('en-GB')
              : null,
            endWindow: msWindowEnd
              ? new Date(msWindowEnd).toLocaleDateString('en-GB')
              : null,
          })
        }
        //sin ventana
        else {
          // console.log({startValidity, endValidity})
          this.validity.push({ startValidity, endValidity })
          this.validityString.push({
            startValidity: startValidity
              ? new Date(startValidity).toLocaleDateString('en-GB')
              : null,
            endValidity: endValidity
              ? new Date(endValidity).toLocaleDateString('en-GB')
              : null,
          })
        }
      })
    },
    /**Envia los datos del formulario para actualizar un material
    * @param {String} formName - El valor del formulario para argumentar  
    */
    submitForm(formName) {
      this.$refs[formName].validate((valid) => {
        //console.log("valid en submitForm", valid) //ojo
        let haveSignals = this.signalsCode.concat(this.signalNext)
        //console.log("haveSignals",haveSignals) //ojo
        //console.log("idEdit", idEdit)
        //console.log("esNecesarioEditarLosMateriales", esNecesarioEditarLosMateriales)
        //console.log("needEditCuts", needEditCuts)
        //console.log()
        //console.log()
        if (valid && haveSignals.length > 0) {
          if (this.idEdit) {
            if (this.esNecesarioEditarLosMateriales) {
              this.needEditCuts = true
            } else {
              console.log('se actualizó el material')
              this.updatedMaterial()
            }
          } else {
            console.log('cree nuevo material')
            this.onSubmit()
          }
        } else {
          this.invalidForm = true
          console.log('error submit!!')
          return false
        }
      })
    },
    /**Envia los datos de un material nuevo*/
    onSubmit() {
      /*Reseteando valores */
      this.validity = []
      this.validityString = []
      /*__________*/
      if (this.form.minutesMaterial.length === 1) {
        this.form.minutesMaterial = '0' + this.form.minutesMaterial
      }
      if (this.form.hoursMaterial.length === 1) {
        this.form.hoursMaterial = '0' + this.form.hoursMaterial
      }
      //posteando ventanas y vigencias
      this.addWindows()
      // Creando las propiedades para videoCutting, usado en la vista CUT
      let videoCuttings = []
      this.form.numChapters.map((el, i, arr) => {
        let oneSeason = {
          season: el.season,
          chapters: el.chapters,
          applyAllChapters: false,
          artisticDuration:
            this.form.hoursMaterial + ':' + this.form.minutesMaterial + ':00', //General y no cambia
          allChapters: {
            artisticDuration:
              this.form.hoursMaterial + ':' + this.form.minutesMaterial + ':00', //Específico y cambia según el totdal de tiempo de cortes
            cuts: [],
          },
          chapterRanges: [],
          individualChapters: [],
        }
        videoCuttings.push(oneSeason)
      })

      // Si un material NO tiene capítulos
      if (
        this.form.numChapters.length === 1 &&
        this.form.numChapters[0].season === '' &&
        this.form.numChapters[0].chapters === ''
      ) {
        this.form.numChapters = []
      } else {
        let objInsert = {}
        // Si un material tiene capitulos, se le agrega la misma vigencia del material a los capitulos
        console.log(this.stringMaterialType, 'this.stringMaterialType')
        for (
          let i = Number(this.form.numChapters[0].firstCap);
          i <= this.form.numChapters[0].lastCap;
          i++
        ) {
          objInsert = {
            chapter: i,
            validity: this.validity,
            nameCap: 'Capítulo ' + i,
            state: 'sin revisar'
          }
          this.form.numChapters[0].infoByChapter.push(objInsert)
        }
      }

      let newMaterial = {
        codMaterial: null,
        originalTitle: this.form.originalTitle.trim(),
        ownTitle: this.form.ownTitle.trim(),
        listTitle: this.form.listTitle.trim(),
        minutesMaterial: this.form.minutesMaterial,
        hoursMaterial: this.form.hoursMaterial,
        numChapters: this.form.numChapters,
        typeOfContent: this.form.typeOfContent,
        codeTypeContent: this.codeTypeContent,
        genre: this.form.genre,
        costCenter: this.form.costCenter.trim(),
        checkedSignals: this.form.checkedSignals,
        canned: true,
        materialWithCuts: false,
        reviewObj: {},
        validity: this.validity,
        validityString: this.validityString,
        videoCutting: videoCuttings,
        userName: this.userName,
        userEmail: this.userEmail,
        materialType: this.form.materialType,
        stringMaterialType: this.stringMaterialType,
        checkedChanels: this.form.checkedChannels,
        geminisCode: null,
        signalsCode: this.signalsCode.concat(this.signalNext),
        beforeDurationMaterial: `${calculateHour(
          this.form.hoursMaterial
        )}:${calculateHour(this.form.minutesMaterial)}:00`,
        durationMaterialCreated: this.createDateTimeForRol(
          `${calculateHour(this.form.hoursMaterial)}:${calculateHour(
            this.form.minutesMaterial
          )}:00`
        ),
        costCenterName: this.form.costCenterName.trim(),
        codeTypeInGrid: this.codeTypeInGrid
      }

      console.log(newMaterial, 'newMaterial post')
      HTTP.post('materials', newMaterial)
        .then((res) => {
          console.log(res.data, 'res.data')
          this.nuevocodigoMaterial = res.data.newCodeMaterial
          let dataType = 'materials'
          this.$store.dispatch('getData', dataType)
          this.$store.commit(
            'updateTextMaterialEnlatados',
            'Actualizando Materiales Enlatados...'
          )
          this.addMaterialModal = true
        })
        .catch((err) => {
          console.log(err)
        })
    },
    /**METODO PARA VERIFICAR SI CONTIENE EL CANAL AMERICA NEXT, PARA QUE LUEGO SE AGREGUE COMO SEÑAL EN ORCL*/
    gettingChannels(val) {
      // METODO PARA VERIFICAR SI CONTIENE EL CANAL AMERICA NEXT, PARA QUE LUEGO SE AGREGUE COMO SEÑAL EN ORCL
      const channelCode = 'NX'
      let hasChannel = false
      const isIncluded = this.signalNext.includes(channelCode)
      val.map((channel) => {
        if (channel == 'América Next') {
          hasChannel = true
          if (!isIncluded) {
            this.signalNext.push(channelCode)
          }
        }
      })
      if (hasChannel == false) {
        if (isIncluded) {
          const indexToRemove = this.signalsCode.indexOf(channelCode)
          this.signalNext.splice(indexToRemove, 1)
        }
      }
      console.log(this.signalNext, 'this.signalNext')
      this.validHaveSignals(this.signalsCode, this.signalNext)
    },
    handleCheckAllChange(val) {
      if (this.materialEdit.checkedSignals) {
        this.materialEdit.checkedSignals = val ? this.signalsTable : []
        this.isIndeterminate = false
      } else {
        this.form.checkedSignals = val ? this.signalsTable : []
        this.isIndeterminate = false
      }
      /*Generando el código de las señales seleccionadas*/
      let arrCode = []
      if (val == true) {
        let arrIndexCode = this.arraySignalCode(this.signalsTable)
        for (var r = 0; r < arrIndexCode.length; r++) {
          arrCode.push(this.signalsByCode[arrIndexCode[r]])
        }
      }
      this.signalsCode = arrCode
      this.validHaveSignals(this.signalsCode, this.signalNext)
    },
    handleCheckedSignalsChange(value) {
      let arrCode = []
      let checkedCount = value.length
      this.checkAll = checkedCount === this.signals.length
      this.isIndeterminate =
        checkedCount > 0 && checkedCount < this.signals.length
      /*Generando el código de las señales seleccionadas*/
      let arrIndexCode = this.arraySignalCode(value)
      for (var r = 0; r < arrIndexCode.length; r++) {
        arrCode.push(this.signalsByCode[arrIndexCode[r]])
      }
      this.signalsCode = arrCode
      this.validHaveSignals(this.signalsCode, this.signalNext)
    },
    validHaveSignals(signalsCode, signalNext) {
      // console.log({signalsCode: this.signalsCode})
      let filterSignals =
        signalsCode == '' ? [] : signalsCode.filter((e) => e !== '')
      // console.log({signalsCode: this.signalsCode, signalNext: this.signalNext, filterSignals})
      if (
        (filterSignals && filterSignals.length > 0) ||
        (signalNext && signalNext.length > 0)
      ) {
        this.isDisabledToUpdate = false
      } else {
        this.isDisabledToUpdate = true
      }
    },
    cleanAllInputs(form) {
      this.$refs[form].resetFields()
      this.isIndeterminate = true
      this.form.numChapters = [{ chapters: '', season: '', infoByChapter: [] }]
      this.editableTabsValue2 = '1'
      this.editableTabs2 = [
        {
          title: '1° Vigencia',
          name: '1',
          contentStart: '',
          contentEnd: '',
        },
      ]
      ;(this.tabIndex = 1), (this.validityString = []) //limpiando validity strings
      this.validity = []
      // this.getMaterial()
    },
    viewListMaterials() {
      this.addMaterialModal = false
      this.$router.push({ name: 'material2' })
    },
    validatestartDate(val) {
      console.log(val, 'val')
      let position = val.index
      let endValidity = this.materialEdit.validity[position].endValidity
      let startValidity = this.materialEdit.validity[position].startValidity
      console.log({
        validity: this.materialEdit.validity,
        endValidity,
        startValidity,
      })
      this.endValidityDate =
        typeof endValidity == 'number' ? new Date(endValidity) : endValidity
      this.startValidityDate =
        typeof startValidity == 'number'
          ? new Date(startValidity)
          : startValidity

      let tab = Number(this.tabsValue)
      console.log({ endValidity, startValidity })
      if (this.startValidityDate >= this.endValidityDate) {
        console.log(this.startValidityDate, 'this.startValidityDate')
        console.log(this.endValidityDate, 'this.endValidityDate')

        this.materialEdit.validity[position].endValidity = null
        if (this.materialEdit.validity.length > tab) {
          for (let i = tab; i < this.materialEdit.validity.length; i++) {
            this.materialEdit.validity[i].startValidity = null
            this.materialEdit.validity[i].endValidity = null
          }
        }
      }
      // console.log(this.materialEdit.validity, 'editando')
    },
    validatestartDateCreated(val) {
      let position = val.index
      let endValidity = this.editableTabs2[position].contentEnd
      let startValidity = this.editableTabs2[position].contentStart
      this.endValidityDate =
        typeof endValidity == 'number' ? new Date(endValidity) : endValidity
      this.startValidityDate =
        typeof startValidity == 'number'
          ? new Date(startValidity)
          : startValidity

      let tab = Number(this.editableTabsValue)
      if (this.startValidityDate >= this.endValidityDate) {
        this.editableTabs2[position].contentEnd = null
        if (this.editableTabs2.length > tab) {
          for (let i = tab; i < this.editableTabs2.length; i++) {
            this.editableTabs2[i].contentStart = null
            this.editableTabs2[i].contentEnd = null
          }
        }
      }
    },
    disabledDueDate(time) {
      let transform =
        typeof this.startValidityDate == 'number'
          ? this.startValidityDate
          : new Date(this.startValidityDate).getTime()
      return time.getTime() < transform + 1
    },
    disabledEnd(time) {
      if (Number(this.tabsValue) > 1) {
        /* let position = Number(this.tabsValue) - 2*/
        let position = this.materialEdit.validity.findIndex(
          (x) => x.name == this.tabsValue
        )
        let elem = this.materialEdit.validity[position].endValidity
        let transform =
          typeof elem == 'number' ? elem : new Date(elem).getTime()
        return time.getTime() < transform + 1
      }
    },
    disabledDueDateCreated(time) {
      let transform =
        typeof this.startValidityDate == 'number'
          ? this.startValidityDate
          : new Date(this.startValidityDate).getTime()
      return time.getTime() < transform + 1
    },
    disabledEndCreated(time) {
      if (Number(this.editableTabsValue) > 1) {
        // let position = Number(this.editableTabsValue) - 2
        let position = this.editableTabs2.findIndex(
          (x) => x.name == this.editableTabsValue
        )
        let elem = this.editableTabs2[position].contentEnd
        let transform =
          typeof elem == 'number' ? elem : new Date(elem).getTime()
        return time.getTime() < transform + 1
      }
    },
    /**Automatiza la generacion del primer capitulo y el ultimo, apareciendo los 2 imputs al asignar la cantidad de capitulos
    * @param {String} newTotalChapters - Cantidad de capitulos del material
    */
    changeTotalCaps(newTotalChapters) {
      /*Si se modifica la cantidad debe modificarse el capitulo final*/
      let hasCuts = null
      let videoCuttingData = null

      if (this.idEdit == '') {
        this.$set(this.form.numChapters[0], 'firstCap', 1)
        this.$set(
          this.form.numChapters[0],
          'lastCap',
          Number(this.form.numChapters[0].firstCap) +
            Number(newTotalChapters) -
            1
        )
      } else {
        this.numChaptersEdit[0].firstCap = 1
        this.numChaptersEdit[0].lastCap =
          Number(this.numChaptersEdit[0].firstCap) +
          Number(newTotalChapters) -
          1
        hasCuts = this.materialEdit.materialWithCuts
        videoCuttingData = this.materialEdit.videoCutting[0]
      }

      this.isDisabledToUpdate = false

      const newAllChapters = Number(newTotalChapters)
      const prevAllChapters = Number(this.prevTotalChapters)

      // Verifica 1ro si el # de capitulos es menor al anterior ingresado y si el material tiene cortes
      if (newAllChapters < prevAllChapters && hasCuts) {
        const { chapterRanges, individualChapters } = videoCuttingData
        // Verifica si los cortes ingresados al material son por rango o individuales
        if (chapterRanges.length > 0 || individualChapters.length > 0) {
          let range = []
          let individual = []
          chapterRanges.map((cut) => {
            for (
              let x = Number(cut.startChapter);
              x < Number(cut.finalChapter) + 1;
              x++
            ) {
              range.push(x)
            }
          })

          individualChapters.map((cut) => {
            individual.push(Number(cut.chapter))
          })

          // En caso tenga cortes por rango de capitulos e individuales los une en un array
          const joinArrayOfCaps = range.concat(individual).sort()

          // Verifica si alguno de los caps con cortes se van a eliminar
          let arrIncludesCap = []
          for (let r = newAllChapters + 1; r < prevAllChapters + 1; r++) {
            if (joinArrayOfCaps.includes(r)) {
              arrIncludesCap.push(r)
            }
          }
          // En caso se quiera eliminar uno de los caps con cortes, muestra el modal de advertencia y deshabilita el boton de ACTUALIZAR
          if (arrIncludesCap.length > 0) {
            this.alertHaveCuts = true
            this.isDisabledToUpdate = true
          }
        }
      }
    },
    isCloseModal(val) {
      this.signalModal = val
    },
    createDateTimeForRol(durationMaterial) {
      const timeInsert = new Date()
      const month = String(timeInsert.getMonth() + 1)
      const transformMonth = month.length == 1 ? `0${month}` : month
      const transformTime = [
        '01',
        transformMonth,
        timeInsert.getFullYear(),
      ].join('/')
      const concatTime = transformTime + ' ' + `${durationMaterial}`
      return concatTime
    },
  },
  watch: {
    verifyChangeModal(val) {
      this.contador += 1
    },
    verifyChangeHours(val) {
      this.count += 1
      if (this.count > 1) {
        this.isModifyDurationMat = true
        let videoCutting =
          this.materialEdit.videoCutting &&
          this.materialEdit.videoCutting.length > 0
            ? this.materialEdit.videoCutting[0]
            : false
        if (videoCutting) {
          this.verificandoSiLosCortesSuperanLaDuracionDelMaterial(videoCutting)
        }
      }
    },
  },
  mounted() {
    HTTP.get(`materials/list/genres`)
      .then((res) => {
        // let listNames = res.data.listGenders.map((el) => {
        //   let mayus = (word) => {
        //     return word[0].toUpperCase() + word.slice(1)
        //   }
        //   return mayus(el.name.toLowerCase())
        // })
        this.genders = res.data.listGenders
      })
      .catch((err) => {
        console.log(err)
      })
  },
  beforeDestroy() {
    this.numChaptersEdit = []
    this.$store.dispatch('getData', 'materials/allMaterials/allMaterials')
  },
  async beforeCreate() {
    await this.$store.dispatch('getData', 'typeMaterial')
  },
  updated(){
    //console.log("infoByChapter desde form", form.numChapters[0].infoByChapter)
  }
}
</script>

<style lang="css">
.text-reference {
  color: red;
  font-size: 12px;
  margin-bottom: 20px;
}
</style>